Bug 1842539 (CVE-2020-11076)

Summary: CVE-2020-11076 rubygem-puma: HTTP Smuggling via an invalid Transfer-Encoding Header
Product: [Other] Security Response Reporter: Guilherme de Almeida Suckevicz <gsuckevi>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED WONTFIX QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: akarol, dmetzger, gmccullo, gtanzill, hvyas, jaruga, jhardy, proguski, roliveri, ruby-packagers-sig, simaishi, smallamp, vondruch
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: rubygem-puma 4.3.4, rubygem-puma 3.12.5 Doc Type: If docs needed, set a value
Doc Text:
A flaw was found in rubygem-puma. An attacker could smuggle an HTTP response, by using an invalid transfer-encoding header.
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-10-28 08:16:23 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 1842540, 1842948, 1843847    
Bug Blocks: 1842541    

Description Guilherme de Almeida Suckevicz 2020-06-01 13:43:09 UTC
In Puma (RubyGem) before 4.3.4 and 3.12.5, an attacker could smuggle an HTTP response, by using an invalid transfer-encoding header. The problem has been fixed in Puma 3.12.5 and Puma 4.3.4.

References:
https://github.com/puma/puma/security/advisories/GHSA-x7jg-6pwg-fx5h
https://github.com/puma/puma/blob/master/History.md#434435-and-31253126--2020-05-22

Upstream commit:
https://github.com/puma/puma/commit/f24d5521295a2152c286abb0a45a1e1e2bd275bd

Comment 1 Guilherme de Almeida Suckevicz 2020-06-01 13:43:26 UTC
Created rubygem-puma tracking bugs for this issue:

Affects: fedora-all [bug 1842540]

Comment 3 Przemyslaw Roguski 2020-06-02 12:41:23 UTC
External References:

https://github.com/puma/puma/security/advisories/GHSA-x7jg-6pwg-fx5h

Comment 4 Przemyslaw Roguski 2020-06-02 12:41:26 UTC
Mitigation:

Mitigation for this issue is either not available or the currently available options do not meet the Red Hat Product Security criteria comprising ease of use and deployment, applicability to widespread installation base or stability.

Comment 6 Przemyslaw Roguski 2020-06-03 08:05:24 UTC
Statement:

Red Hat Gluster Storage 3 Web Administration component uses affected RubyGem Puma, which does not have the http body chunk verification.